%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This file is part of QTempIntMiner.
%
% QTempIntMiner is free software: you can redistribute it and/or modify
% it under the terms of the GNU Affero General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% QTempIntMiner is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% Affero GNU General Public License for more details.
%
% You should have received a copy of the GNU Affero General Public License
% along with QTempIntMiner.  If not, see <http://www.gnu.org/licenses/>.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function Ex=GenExample(NbreEx,show,NbSymb, Size)
% Generate NbEx examples of a random pattern prototype
% Usage
%   - NbEx : Number of example to generate, required.
%   - show : if >0 print the generated examples, if >1 draw a figure with
%   the examples, default 0.
%   - NbSymb : Number of available symboles, default 5.
%   - Size   : Size of the prototype (ie its number of symbols)
%
% Returns : Returns an array with the generated examples.
%
% Author : Guyet T. <thomas.guyet@irisa.fr>

if(nargin<2)
   show=0;
end
if(nargin<3)
   NbreSymb=5;
end
if(nargin<4)
   Taille=4;
end

P=GenProto(Size,NbSymb,1);

if(show>0)
   disp('Prototype');
   disp(P);
   if(show>1)
      xlim([0,15]);
      subplot(NbEx+1,1,1);
      viewScen(P([1,2,4],:),cmap,0);
      title('Prototype');
   end
end

Ex=cell(NbEx,1);
for i=1:NbEx
   example=GenScen(P,NbSymb,0.2);
   Ex(i)={exemple};
   if(show>0)
      disp('example')
      disp(example);
      if(show>1)
	      xlim([0,15]);
         subplot(NbEx+1,1,i+1);
         viewScen(example,cmap,0);
      end
   end
end

