%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This file is part of QTempIntMiner.
%
% QTempIntMiner is free software: you can redistribute it and/or modify
% it under the terms of the GNU Affero General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% QTempIntMiner is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% Affero GNU General Public License for more details.
%
% You should have received a copy of the GNU Affero General Public License
% along with QTempIntMiner.  If not, see <http://www.gnu.org/licenses/>.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

defaultVar=0.3;
defaultLVar=0.3;
NbreEx=20;
propBruit=0.4;
NbreSymb=10;
bruitStruct=0.4;
scenLength=15;

% Prototype with twin symbols
P=[1  ,2  ,3  ,2 ;...
   2  ,5  ,8  ,12;...
   defaultVar,defaultVar,defaultVar,defaultVar;...
   1  ,0.5, 2  ,0.5;...
   defaultLVar,defaultLVar,defaultLVar,defaultLVar];

Taille=size(P,2);

tempDistinction=0

Ex=cell([NbreEx 1]);
for i=1:NbreEx
    if(rand(1)>propBruit)
        if(tempDistinction)
            %Generate an example based on P or P2
            if(rand(1)>0.5)
                Ex{i}=GenScen(P,NbreSymb,bruitStruct);
            else
                Ex{i}=GenScen(P2,NbreSymb,bruitStruct);
            end
        else
            %Generate an example based on P
            Ex{i}=GenScen(P,NbreSymb,bruitStruct);
        end
        
    else
        Ex{i}=GenScenAlea(Taille,NbreSymb,1,scenLength);
    end
end

WriteExamples(Ex, 'testfile.dat');

