%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This file is part of QTempIntMiner.
%
% QTempIntMiner is free software: you can redistribute it and/or modify
% it under the terms of the GNU Affero General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% QTempIntMiner is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% Affero GNU General Public License for more details.
%
% You should have received a copy of the GNU Affero General Public License
% along with QTempIntMiner.  If not, see <http://www.gnu.org/licenses/>.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function Mr=EM_TemporalPatternConstruction(itemset, itemloc)
%
% Author : Guyet T. <thomas.guyet@irisa.fr>

    global d;
    
    p_dim=size(itemset, 2);
    v=zeros(p_dim,2);
    hr=[];
    %compute the volume of the prefix
    for ide = 1:size(itemloc,2)
        e= itemloc{ide}.is;
        vol=1;
        for dim=1:p_dim
            vol=vol*e(3,dim);
            v(dim,:)=e(2:3,dim)';
        end
        nbre = max(1,round((d^p_dim)*vol)); %at least 1 examples
        % Random generation of points in the pattern volume
        r=rand(nbre,p_dim);
        for genid=1:nbre
            r(genid,:)=v(:,1)'+r(genid,:).*v(:,2)';
            hr=[r(genid,:);hr];
        end
    end

    %Launch the EM algorithm on hr to extract the temporal extends
    % The function prunes the unfrequent patterns
    %Mr=createPatterns([],itemset', hr, nbis/size(Ex,1), f);
    Mr=createPatterns([],itemset', hr, 1, 0);
