% ========================================================
% Utilisation de AGGCLUST de la DCPR Toolbox
% ========================================================

close all;
clear all;


% =========================== Lecture des donnes

data = load('data2.txt');
ndata=size(data,1);


% Attention, si trop de donnes, la mthode rame, alors limitation
%  ndata=300

if ndata>300
     fprintf('Warning : trop de donnes, on en prend 300 au hasard\n');
     iii=randperm(ndata);
     ndata=300;
     data=data(sort(iii(1:ndata)),:);
     clear iii;
 end

% ============================ Paramtres de la fonction AGGCLUST
%methode='single';
methode='complete';


timp=cputime;

% Calcul de la matrice de distance
for i = 1:ndata,
    for j = 1:ndata,
        distance(i, j) = norm(data(i,:)-data(j,:));
    end
end
% Diagonal elements should always be inf.
for i = 1:ndata, distance(i, i) = inf; end

level = aggclust(distance,methode);

timp=cputime-timp;
fprintf('\tL''algorithme a dur %3.2f secondes\n',timp);



% ============================= Plusieurs modes d'affichage
%
% [0] AFFICHAGE DES DONNEES
% ---------------------------------------------------------
figure;
plot(data(:,1),data(:,2), 'r+');


% [1] AFFICHAGE DE LA COURBE HAUTEUR/NIVEAU DU DENDROGRAMME
% ---------------------------------------------------------
figure;
plot([level.height], 'r-');
xlabel('Niveau');
ylabel('Hauteur');
title('Hauteur vs. niveau');


% [2] AFFICHAGE DU DENDROGRAMME
% ---------------------------------------------------------
figure
dendro(level);


% [3] AFFICHAGE PROGRESSIF DU REGROUPEMENT DES POINTS (2D)
% ---------------------------------------------------------
linkclu(data, distance, level);



