function d=DeCarvahlo94(I1, I2, q, w)

d=0;
n=size(I1,1);
try
    if( n~=size(I2,1) || size(w,1)~=n)
        disp('DeCarvahlo94 size error');
        return;
    end
    if( sum(w)~=1 || min(w)<0 )
        w=ones(n, 1)/n;
    end
catch ME
    %ME.message
    w=ones(n, 1)/n;
end

try
    if( isempty(1) || q<1)
        q=1;
    end
catch ME
    %ME.message
    q=1;
end

for i=1:n
    a = max(0, min(I1(i,2), I2(i,2)) - max(I1(i,1),I2(i,1)));
    if( (I1(i,1)< I2(i,1) && I1(i,2)>I2(i,1)) || (I1(i,1)< I2(i,2) && I1(i,2)>I2(i,2)))
        b = max(0, I2(i,1)-I1(i,1)) + max(0, I1(i,2)-I2(i,2));
    else
        b = I1(i,2) - I1(i,1);
    end
    
    if( (I2(i,1)< I1(i,1) && I2(i,2)>I1(i,1)) || (I2(i,1)< I1(i,2) && I2(i,2)>I1(i,2)))
        g = max(0, I1(i,1)-I2(i,1)) + max(0, I2(i,2)-I1(i,2));
    else
        g = I2(i,2) - I2(i,1);
    end
    
    sc1 = a/(a+b+g);
    sc2=2*a/(2*a+b+g);
    sc3=a/(a+2*(b+g));
    sc4=0.5*(a/(a+b)+a/(a+g));
    sc5=a/sqrt((a+b)*(a+g));
    
    phi_c = sc1;
    
    if( I1(i,2)<I2(i,1) || I2(i,2) < I1(i,1)) %disjoint
        phi_p = abs(min(I1(i,2), I2(i,2)) - max(I1(i,1), I2(i,1)))/( max(I1(i,2), I2(i,2)) - min(I1(i,2), I2(i,2)));
    else
        phi_p=0;
    end
    d = d + w(i,1)*( 0.5*(phi_p+phi_c) )^q;
end

d = d^(1/q);


