%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This file is part of QTempIntMiner.
%
% QTempIntMiner is free software: you can redistribute it and/or modify
% it under the terms of the GNU Affero General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% QTempIntMiner is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% Affero GNU General Public License for more details.
%
% You should have received a copy of the GNU Affero General Public License
% along with QTempIntMiner.  If not, see <http://www.gnu.org/licenses/>.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [Mr, owner] = Separation_TemporalConstruction(itemset, itemloc)
%
% Author : Guyet T. <thomas.guyet@irisa.fr>
% GNU Licenced, 2013
%
% Construction des intervals temporels
%

	%% construct the set of intervals of dimension 1
	
    p_dim=size(itemset, 2);
    
    %disp 'start'
    %p_dim
    		
    %[owner, Separations, first_interval] = Separation_TemporalConstruction_Rec(itemloc, p_dim);
    owner = Separation_TemporalConstruction_Rec(itemloc, p_dim);
    
    uowner=unique(owner);
    
    %% new temporal itemset construction
    Mr=[];
    if size(uowner,1)==1
  		Intervals=[]; %%TODO améliorer cela
		for ide = 1:size(itemloc,2)
			e = itemloc{ide}.is;
			I = [e(2,p_dim) e(3,p_dim)+e(2,p_dim)];
			if( isempty(Intervals) ) 
				Intervals = I;
			else
				Intervals = cat(1,Intervals,I);
			end
		end
        new_itemset=itemset;
        new_itemset(2,p_dim)=min(Intervals(:,1));
        new_itemset(3,p_dim)=max(Intervals(:,2))-new_itemset(2,p_dim);
        Mr=new_itemset;
        return
    else
		Mr=[];
		i=1;
		for id_cluster=(uowner')		
			new_itemset=itemset;
			for d = 1:p_dim %%TODO : améliorer cela !!
				Intervals=[];
				for ide = 1:size(itemloc,2)
					e = itemloc{ide}.is;
		
					I = [e(2,d) e(3,d)+e(2,d)];
		
					if( isempty(Intervals) ) 
						Intervals = I;
					else
						Intervals = cat(1,Intervals,I);
					end
				end
			
				new_itemset(2,d)=min( Intervals(owner==id_cluster, 1) );
				new_itemset(3,d)=max( Intervals(owner==id_cluster, 2) )-new_itemset(2,d);
			end
			if( isempty(Mr) )
				Mr=new_itemset;
			else
				Mr=cat(3, Mr, new_itemset);
			end
			
			%on recale les indices pour leurs valeurs correspondent aux indices de Mr
			if i~=id_cluster
				if max(owner==i)==1
					disp 'GROS GROS PB' %normalement ca n'arrive pas !!
				end
				owner(owner==id_cluster)=i;
			end
			i=i+1;
		end
	end
    
end
