%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This file is part of QTempIntMiner.
%
% QTempIntMiner is free software: you can redistribute it and/or modify
% it under the terms of the GNU Affero General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% QTempIntMiner is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% Affero GNU General Public License for more details.
%
% You should have received a copy of the GNU Affero General Public License
% along with QTempIntMiner.  If not, see <http://www.gnu.org/licenses/>.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [owner] = Separation_TemporalConstruction_Rec(itemloc, dim)
%
% Author : Guyet T. <thomas.guyet@irisa.fr>
% GNU Licenced, 2013
%
% retourne un vecteur d'identifiant avec des valeurs >0 

	%% construct the set of intervals of dimension 1
	% get the set of intervals for dimension dim
	Intervals=[];
	for ide = 1:size(itemloc,2)
		e = itemloc{ide}.is;
		
		I = [e(2,dim) e(3,dim)+e(2,dim)];
		
		if( isempty(Intervals) ) 
		    Intervals = I;
		else
		    Intervals = cat(1,Intervals,I);
		end
	end
		
    [owner, Separations, first_interval] = Intervals_Separation(Intervals);
    
	%dim
	%owner
    
    %% recursion only if there is some separations and that dimension style exists
    if ~isempty(Separations) && dim-1>0
    	m = max(owner);
		for id_cluster=(unique(owner)')
			%id_cluster
			litemloc = itemloc(owner==id_cluster);
			cown = Separation_TemporalConstruction_Rec(litemloc, dim-1);
			owner(owner==id_cluster) = cown + m;
			m=max(cown)+m;
		end
	end
	
	%disp 'modified'
	%owner
    
%end function
end
