%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This file is part of QTempIntMiner.
%
% QTempIntMiner is free software: you can redistribute it and/or modify
% it under the terms of the GNU Affero General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% QTempIntMiner is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% Affero GNU General Public License for more details.
%
% You should have received a copy of the GNU Affero General Public License
% along with QTempIntMiner.  If not, see <http://www.gnu.org/licenses/>.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function viewScen(Sv, cmap, DrawFig, decay, ypos, height)
% Function to draw scenarios
% ViewScen(Sv,cmap,DrawFig)  	
%   Sv : a scenario matrix of size 3xX, where X is the number of symbols of Sv	
%   cmap : An previoulsy initialized color map (eg cmap=colormap( hsv(SymbNb) ) )
%
% Author : Guyet T. <thomas.guyet@irisa.fr>

if nargin<3, DrawFig=1; decay=1; ypos=0; height=1; end;
if nargin<4, decay=1; ypos=0; height=1; end;

if DrawFig
   figure;
   colormap(cmap);
end

if(size(Sv,3) == 1)
    hold on;

    if decay
        for i=1:size(Sv,2)
            x=[Sv(2,i);Sv(2,i);Sv(2,i)+Sv(3,i);Sv(2,i)+Sv(3,i)];
            y=[Sv(1,i)+1;Sv(1,i);Sv(1,i);Sv(1,i)+1];
            fill(x,y,cmap(Sv(1,i),:));
        end
    else
        for i=1:size(Sv,2)
            x=[Sv(2,i);Sv(2,i);Sv(2,i)+Sv(3,i);Sv(2,i)+Sv(3,i)];
            y=[ypos+height;ypos;ypos;ypos+height];
            fill(x,y,cmap(Sv(1,i),:));
        end
    end

    hold off;
else
    n=size(Sv,3);
    for(i=1:n)
        subplot(n,1,i);
        viewScen(Sv(:,:,i),cmap,0);
    end
end
